# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.10, developed by Pure Storage, Inc. (http://www.purestorage.com/). 

    OpenAPI spec version: 2.10
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re

import six
import typing

from ....properties import Property
if typing.TYPE_CHECKING:
    from pypureclient.flashblade.FB_2_10 import models

class Bucket(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'id': 'str',
        'quota_limit': 'int',
        'versioning': 'str',
        'bucket_type': 'str',
        'created': 'int',
        'object_count': 'int',
        'eradication_config': 'BucketEradicationConfig',
        'space': 'SpaceExtended',
        'object_lock_config': 'ObjectLockConfigResponse',
        'time_remaining': 'int',
        'destroyed': 'bool',
        'hard_limit_enabled': 'bool',
        'retention_lock': 'str',
        'account': 'FixedReference'
    }

    attribute_map = {
        'name': 'name',
        'id': 'id',
        'quota_limit': 'quota_limit',
        'versioning': 'versioning',
        'bucket_type': 'bucket_type',
        'created': 'created',
        'object_count': 'object_count',
        'eradication_config': 'eradication_config',
        'space': 'space',
        'object_lock_config': 'object_lock_config',
        'time_remaining': 'time_remaining',
        'destroyed': 'destroyed',
        'hard_limit_enabled': 'hard_limit_enabled',
        'retention_lock': 'retention_lock',
        'account': 'account'
    }

    required_args = {
    }

    def __init__(
        self,
        name=None,  # type: str
        id=None,  # type: str
        quota_limit=None,  # type: int
        versioning=None,  # type: str
        bucket_type=None,  # type: str
        created=None,  # type: int
        object_count=None,  # type: int
        eradication_config=None,  # type: models.BucketEradicationConfig
        space=None,  # type: models.SpaceExtended
        object_lock_config=None,  # type: models.ObjectLockConfigResponse
        time_remaining=None,  # type: int
        destroyed=None,  # type: bool
        hard_limit_enabled=None,  # type: bool
        retention_lock=None,  # type: str
        account=None,  # type: models.FixedReference
    ):
        """
        Keyword args:
            name (str): Name of the object (e.g., a file system or snapshot).
            id (str): A non-modifiable, globally unique ID chosen by the system. 
            quota_limit (int): The effective quota limit applied against the size of the bucket, displayed in bytes. If unset, the bucket is unlimited in size. 
            versioning (str): The versioning state for objects within the bucket. Valid values are `none`, `enabled`, and `suspended`. 
            bucket_type (str): The bucket type for the bucket. 
            created (int): Creation timestamp of the object.
            object_count (int): The count of objects within the bucket.
            eradication_config (BucketEradicationConfig)
            space (SpaceExtended): The space specification of the bucket.
            object_lock_config (ObjectLockConfigResponse)
            time_remaining (int): Time in milliseconds before the bucket is eradicated. `null` if not destroyed. 
            destroyed (bool): Is the bucket destroyed? 
            hard_limit_enabled (bool): If set to `true`, the bucket's size, as defined by `quota_limit`, is used as a hard limit quota. If set to `false`, a hard limit quota will not be applied to the bucket, but soft quota alerts will still be sent if the bucket has a value set for `quota_limit`. 
            retention_lock (str): If set to `ratcheted`, then `object_lock_config.default_retention_mode` cannot be changed if set to `compliance`. In this case, the value of `object_lock_config.default_retention` can only be increased and `object_lock_config.default_retention_mode` cannot be changed once set to `compliance`. Valid values are `unlocked` and `ratcheted`. Contact Pure Technical Services to change `ratcheted` to `unlocked`. 
            account (FixedReference)
        """
        if name is not None:
            self.name = name
        if id is not None:
            self.id = id
        if quota_limit is not None:
            self.quota_limit = quota_limit
        if versioning is not None:
            self.versioning = versioning
        if bucket_type is not None:
            self.bucket_type = bucket_type
        if created is not None:
            self.created = created
        if object_count is not None:
            self.object_count = object_count
        if eradication_config is not None:
            self.eradication_config = eradication_config
        if space is not None:
            self.space = space
        if object_lock_config is not None:
            self.object_lock_config = object_lock_config
        if time_remaining is not None:
            self.time_remaining = time_remaining
        if destroyed is not None:
            self.destroyed = destroyed
        if hard_limit_enabled is not None:
            self.hard_limit_enabled = hard_limit_enabled
        if retention_lock is not None:
            self.retention_lock = retention_lock
        if account is not None:
            self.account = account

    def __setattr__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `Bucket`".format(key))
        self.__dict__[key] = value

    def __getattribute__(self, item):
        value = object.__getattribute__(self, item)
        if isinstance(value, Property):
            return None
        else:
            return value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            if hasattr(self, attr):
                value = getattr(self, attr)
                if isinstance(value, list):
                    result[attr] = list(map(
                        lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                        value
                    ))
                elif hasattr(value, "to_dict"):
                    result[attr] = value.to_dict()
                elif isinstance(value, dict):
                    result[attr] = dict(map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict") else item,
                        value.items()
                    ))
                else:
                    result[attr] = value
        if issubclass(Bucket, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Bucket):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
