# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.3, developed by Pure Storage, Inc. (http://www.purestorage.com/). 

    OpenAPI spec version: 2.3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re

import six
import typing

from ....properties import Property
if typing.TYPE_CHECKING:
    from pypureclient.flashblade.FB_2_3 import models

class FileSystemSnapshot(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'id': 'str',
        'owner': 'FixedReference',
        'time_remaining': 'int',
        'destroyed': 'bool',
        'created': 'int',
        'source': 'FixedLocationReference',
        'suffix': 'str',
        'owner_destroyed': 'bool',
        'policy': 'FixedLocationReference'
    }

    attribute_map = {
        'name': 'name',
        'id': 'id',
        'owner': 'owner',
        'time_remaining': 'time_remaining',
        'destroyed': 'destroyed',
        'created': 'created',
        'source': 'source',
        'suffix': 'suffix',
        'owner_destroyed': 'owner_destroyed',
        'policy': 'policy'
    }

    required_args = {
    }

    def __init__(
        self,
        name=None,  # type: str
        id=None,  # type: str
        owner=None,  # type: models.FixedReference
        time_remaining=None,  # type: int
        destroyed=None,  # type: bool
        created=None,  # type: int
        source=None,  # type: models.FixedLocationReference
        suffix=None,  # type: str
        owner_destroyed=None,  # type: bool
        policy=None,  # type: models.FixedLocationReference
    ):
        """
        Keyword args:
            name (str): A name chosen by the user. Can be changed. Must be locally unique. 
            id (str): A non-modifiable, globally unique ID chosen by the system. 
            owner (FixedReference): A reference to the file system that owns this snapshot. If the owner is destroyed, this will be destroyed. 
            time_remaining (int): Time in milliseconds before the file system snapshot is eradicated. `null` if not destroyed. 
            destroyed (bool): Is the file system snapshot destroyed? If not specified, defaults to `false`. 
            created (int): Creation timestamp of the object.
            source (FixedLocationReference): A reference to the file system that was the source of the data in this snapshot. Normally this is the same as the owner, but if the snapshot is replicated, the source is the original file system. 
            suffix (str): The suffix of the snapshot, e.g., `snap1`.
            owner_destroyed (bool): Is the owning file system destroyed?
            policy (FixedLocationReference): A reference to the associated policy.
        """
        if name is not None:
            self.name = name
        if id is not None:
            self.id = id
        if owner is not None:
            self.owner = owner
        if time_remaining is not None:
            self.time_remaining = time_remaining
        if destroyed is not None:
            self.destroyed = destroyed
        if created is not None:
            self.created = created
        if source is not None:
            self.source = source
        if suffix is not None:
            self.suffix = suffix
        if owner_destroyed is not None:
            self.owner_destroyed = owner_destroyed
        if policy is not None:
            self.policy = policy

    def __setattr__(self, key, value):
        if key not in self.attribute_map:
            raise KeyError("Invalid key `{}` for `FileSystemSnapshot`".format(key))
        self.__dict__[key] = value

    def __getattribute__(self, item):
        value = object.__getattribute__(self, item)
        if isinstance(value, Property):
            return None
        else:
            return value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            if hasattr(self, attr):
                value = getattr(self, attr)
                if isinstance(value, list):
                    result[attr] = list(map(
                        lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                        value
                    ))
                elif hasattr(value, "to_dict"):
                    result[attr] = value.to_dict()
                elif isinstance(value, dict):
                    result[attr] = dict(map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict") else item,
                        value.items()
                    ))
                else:
                    result[attr] = value
        if issubclass(FileSystemSnapshot, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FileSystemSnapshot):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
